/*******************************************************************************
**	ICS 5300 (GENDAC) fixed clocks
********************************************************************************
**
   Copyright (c)	1995-1997	Steffen Seeger
**
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
********************************************************************************
**
**	$Log: gendac.c,v $
**	Revision 1.5  1998/11/19 02:43:04  marcus
**	License change
**	
**	Revision 1.4  1998/10/25 18:07:32  marcus
**	More namespace cleanups
**	
**	Revision 1.3  1998/10/04 03:17:05  brian
**	Added private data hook to KGI_COMMON -- clean and recompile kgicon!
**	
**	Revision 1.2  1998/08/19 20:47:31  marcus
**	Changed ggi/*.h includes to kgi/*.h includes
**	Fixed most of the remaining graphics -> accel changes
**	
**	Revision 1.1  1998/07/07 08:01:52  taylorj
**	*** empty log message ***
**	
**	Revision 1.4  1997/11/08 15:12:41  becka
**	Namespace cleanup ... probably broke all and everything ...
**	
**	Revision 1.3  1997/10/03 11:25:05  seeger
**	minor:	added CVS logging, maintainer definition and standard headers.
**	
*/

#include <kgi/maintainers.h>
#define	MAINTAINER	Steffen_Seeger
#define	DRIVER_NAME	"ICS 5300 GENDAC clock chip driver"
#define	DRIVER_REV	"$Revision: 1.5 $"

#include <kgi/module.h>

static struct kgi_clock clock =
{
	"ICS",			/* manufacturer		*/
	"5300 (GENDAC)",	/* model		*/
	GM_ALL,			/* supported modes	*/
	0,			/* special capabilities	*/
	{ 0x7FFF, 0x7FFF },	/* maximum resolution	*/
	NULL,			/* Private data hook	*/
	CLK_TYPE_FIXED,		/* fixed clock values	*/

	/*	The clock values. Note that they have to be in descending
	**	order and that there must be no repetitions.
	*/

	{{ 75000000,  65000000,  44889000,  40000000,
	   36000000,  31500000,  28322000,  25175000,
	          0,         0,         0,         0,
	          0,         0,         0,         0
	}}
};

/*
**	Driving CS[0:3] to clkindex[i] selects clock.clock.freq[i].
*/

static kgiu8 clkindex[MAX_FIXED_CLOCKS] =
{	0x07, 0x06, 0x05, 0x04,
	0x03, 0x02, 0x01, 0x00,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF
};

static inline struct kgi_clock *init_clock(void)
{
	/*	no detection, the ramdac does this.
	*/
	return &clock;
}

static inline void done_clock(void)
{
}

#include "fixed.inc"

